## mx-conky 25.08

=== CMakeLists.txt ===
# **********************************************************************
# * Copyright (C) 2017-2025 MX Authors
# *
# * Authors: Adrian
# *          MX Linux <http://mxlinux.org>
# *
# * This file is part of mx-conky.
# *
# * mx-conky is free software: you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation, either version 3 of the License, or
# * (at your option) any later version.
# *
# * mx-conky is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with mx-conky.  If not, see <http://www.gnu.org/licenses/>.
# **********************************************************************/

cmake_minimum_required(VERSION 3.16)
project(mx-conky VERSION 1.0.0 LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Option to use clang for testing builds
option(USE_CLANG "Use clang compiler" OFF)
if(USE_CLANG)
    set(CMAKE_C_COMPILER clang)
    set(CMAKE_CXX_COMPILER clang++)
    set(CMAKE_CXX_COMPILER_ID "Clang")
    message(STATUS "Using clang compiler")
endif()

# Find Qt6 components
find_package(Qt6 REQUIRED COMPONENTS Core Widgets LinguistTools)

# Qt6 configuration
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

# Compiler flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wpedantic -pedantic")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror=return-type -Werror=switch")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror=uninitialized")

# Add compiler-specific flags
if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror=return-stack-address")
else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror=return-local-addr")
    # Suppress false positive LTO warnings with Qt6 QHash
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-alloc-size-larger-than")
endif()

# Handle different build types
if(CMAKE_BUILD_TYPE STREQUAL "Release")
    add_definitions(-DNDEBUG)
    set(CMAKE_CXX_FLAGS_RELEASE "-O3")
    if(NOT CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -flto=auto")
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -flto=auto")
    endif()
endif()

# Handle 32-bit builds and debian builds differently
if(CMAKE_SIZEOF_VOID_P EQUAL 4 OR DEFINED ENV{DEB_BUILD_OPTIONS})
    # Reduce strict flags for 32-bit compatibility or debian builds
    message(STATUS "32-bit build or debian build detected, reducing compiler strictness")
else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
endif()

add_definitions(-DQT_DEPRECATED_WARNINGS)

# Source files
set(SOURCES
    src/main.cpp
    src/mainwindow.cpp
    src/cmd.cpp
    src/conkyitem.cpp
    src/conkymanager.cpp
    src/conkylistwidget.cpp
    src/settingsdialog.cpp
    src/conkycustomizedialog.cpp
    src/previewdialog.cpp
)

# Header files
set(HEADERS
    src/mainwindow.h
    src/cmd.h
    src/conkyitem.h
    src/conkymanager.h
    src/conkylistwidget.h
    src/settingsdialog.h
    src/conkycustomizedialog.h
    src/previewdialog.h
)

# Translation files - dynamically find all .ts files
file(GLOB TS_FILES "translations/*.ts")

# Resource files
set(RESOURCES
    images.qrc
)

# Create the executable
add_executable(mx-conky ${SOURCES} ${HEADERS} ${RESOURCES})

# Add include directories
target_include_directories(mx-conky PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})

# Link Qt6 libraries
target_link_libraries(mx-conky Qt6::Core Qt6::Widgets)

# Handle translations - generate .qm files in translations/ directory
set(QM_FILES)
foreach(TS_FILE ${TS_FILES})
    get_filename_component(TS_BASENAME ${TS_FILE} NAME_WE)
    set(QM_FILE ${CMAKE_CURRENT_SOURCE_DIR}/translations/${TS_BASENAME}.qm)
    add_custom_command(
        OUTPUT ${QM_FILE}
        COMMAND Qt6::lrelease ${TS_FILE} -qm ${QM_FILE}
        DEPENDS ${TS_FILE}
        COMMENT "Generating ${QM_FILE}"
    )
    list(APPEND QM_FILES ${QM_FILE})
endforeach()

add_custom_target(translations ALL DEPENDS ${QM_FILES})
add_dependencies(mx-conky translations)

# Add cleanup target to remove .qm files before lupdate
add_custom_target(clean-translations
    COMMAND ${CMAKE_COMMAND} -E remove ${CMAKE_CURRENT_SOURCE_DIR}/translations/*.qm
    COMMENT "Cleaning translation files"
)

# Add lupdate target for updating translation files
add_custom_target(lupdate
    COMMAND Qt6::lupdate ${CMAKE_CURRENT_SOURCE_DIR}/src/*.cpp ${CMAKE_CURRENT_SOURCE_DIR}/src/*.h -ts ${TS_FILES}
    DEPENDS clean-translations
    COMMENT "Updating translation files with lupdate"
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

# Installation
install(TARGETS mx-conky DESTINATION bin)

## mx-conky 18.12.1

=== debian/changelog ===
mx-conky (18.12.1) mx; urgency=medium

  * open file with "Open With..." or by passing an argument at command line

 -- Adrian <adrian@mxlinux.org>  Thu, 27 Dec 2018 12:41:40 -0500

mx-conky (18.12) mx; urgency=medium

  * add scroll bar
  * save window geometry

 -- Adrian <adrian@mxlinux.org>  Sun, 23 Dec 2018 12:57:51 -0500

mx-conky (18.11) mx; urgency=medium

  * updated translations

 -- Adrian <adrian@mxlinux.org>  Fri, 30 Nov 2018 12:14:12 -0500

mx-conky (18.10) mx; urgency=medium

  * updated translations

 -- Adrian <adrian@mxlinux.org>  Sun, 14 Oct 2018 18:40:03 -0400

mx-conky (18.9) mx; urgency=medium

  * change editor to xdg-open

 -- Adrian <adrian@mxlinux.org>  Sat, 15 Sep 2018 13:17:21 -0400

mx-conky (18.8) mx; urgency=medium

  * fix icon other themes

 -- Adrian <adrian@mxlinux.org>  Sat, 11 Aug 2018 16:13:56 -0400

mx-conky (18.6.1) mx; urgency=medium

  * added changelog button
  * use libcmd

 -- Adrian <adrian@mxlinux.org>  Sun, 24 Jun 2018 21:08:02 -0400

mx-conky (18.6) mx; urgency=medium

  * new translations

 -- Adrian <adrian@mxlinux.org>  Mon, 18 Jun 2018 14:22:03 -0400

mx-conky (18.3) mx; urgency=medium

  * new translations

 -- Adrian <adrian@mxlinux.org>  Fri, 02 Mar 2018 10:32:36 -0500

mx-conky (18.2) mx; urgency=medium

  * new translations

 -- Adrian <adrian@mxlinux.org>  Sat, 10 Feb 2018 01:43:47 -0500

mx-conky (17.12+1) mx; urgency=medium

  * update translations

 -- Adrian <adrian@mxlinux.org>  Mon, 11 Dec 2017 23:16:33 -0500

mx-conky (17.12) mx; urgency=medium

  * new translations

 -- Adrian <adrian@mxlinux.org>  Mon, 04 Dec 2017 14:33:40 -0500

mx-conky (17.11) mx; urgency=medium

  * added translations

 -- Adrian <adrian@mxlinux.org>  Tue, 28 Nov 2017 17:49:27 -0500

mx-conky (0.17.11+4) mx; urgency=medium

  * hide GUI while editing file
  * added links in mesage box
  * fix version update to config file

 -- Adrian <adrian@mxlinux.org>  Mon, 20 Nov 2017 14:03:58 -0500

mx-conky (0.17.11+3) mx; urgency=medium

  * fix alignment
  * remove dots from backup file


 -- Adrian <adrian@mxlinux.org>  Thu, 16 Nov 2017 10:05:46 -0500

mx-conky (0.17.11+2) mx; urgency=medium

  * fix alignment

 -- Adrian <adrian@mxlinux.org>  Wed, 15 Nov 2017 11:04:24 -0500

mx-conky (0.17.11+1) mx; urgency=medium

  * version bump

 -- Adrian <adrian@mxlinux.org>  Wed, 15 Nov 2017 09:52:16 -0500

mx-conky (0.17.11) mx; urgency=medium

  * GUI changes
  * message data update

 -- Adrian <adrian@mxlinux.org>  Tue, 14 Nov 2017 10:16:09 -0500

mx-conky (0.17.10) mx; urgency=medium

  * Initial build

 -- Adrian <adrian@mxlinux.org>  Mon, 30 Oct 2017 14:28:37 -0400

=== debian/control ===
Source: mx-conky
Section: admin
Priority: optional
Maintainer: Adrian <adrian@mxlinux.org>
Build-Depends: qt5-qmake,
	qt5-default,
        qttools5-dev-tools,
	debhelper (>=9),
	libcmd
Standards-Version: 3.9.8
Vcs-Git: git://github.com/AdrianTM/mx-conky

Package: mx-conky
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, mx-conky-data
Description: MX Conky
 MX Conky is a tool used for manipulating detailed attributes such as color or formats

=== debian/rules ===
#!/usr/bin/make -f

QMAKE_OPTS = DEFINES+=NO_DEBUG_ON_CONSOLE
MAKE_OPTS  = QMAKE=qmake-qt5 LRELEASE=lrelease-qt5 QMAKE_OPTS="$(QMAKE_OPTS)"

override_dh_auto_clean:
	dh_auto_clean
	rm -f src/translations/*.qm

override_dh_auto_build:
	lrelease mx-conky.pro
	dh_auto_build -- $(MAKE_OPTS)

override_dh_auto_install:
	dh_auto_install -- $(MAKE_OPTS)

override_dh_builddeb:
	dh_builddeb -- -Z xz

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

%:
	dh $@ --parallel

## mx-conky 19.1

=== debian/changelog ===
mx-conky (19.1) mx; urgency=medium

  * updated translations

 -- Adrian <adrian@mxlinux.org>  Wed, 23 Jan 2019 09:47:41 -0500

## mx-conky 19.2

=== debian/changelog ===
mx-conky (19.2) mx; urgency=medium

  * fix: open file

 -- Adrian <adrian@mxlinux.org>  Mon, 04 Feb 2019 11:46:08 -0500

## mx-conky 19.2.1

=== debian/changelog ===
mx-conky (19.2.1) mx; urgency=medium

  * make finding file editor more robust

 -- Adrian <adrian@mxlinux.org>  Mon, 04 Feb 2019 16:56:04 -0500

## mx-conky 19.4

=== debian/changelog ===
mx-conky (19.4) mx; urgency=medium

  * updated translations

 -- Adrian <adrian@mxlinux.org>  Fri, 05 Apr 2019 11:30:12 -0400

## mx-conky 19.7

=== debian/changelog ===
mx-conky (19.7) mx; urgency=medium

  * fix windows buttons for Buster

 -- Adrian <adrian@mxlinux.org>  Sun, 07 Jul 2019 13:37:47 -0400

## mx-conky 19.7.1

=== debian/changelog ===
mx-conky (19.7.1) mx; urgency=medium

  * new icon

 -- Adrian <adrian@mxlinux.org>  Fri, 26 Jul 2019 14:37:14 -0400

=== debian/control ===
Source: mx-conky
Section: admin
Priority: optional
Maintainer: Adrian <adrian@mxlinux.org>
Build-Depends: debhelper (>=9),
               libcmd,
               qt5-default,
               qt5-qmake,
               qttools5-dev-tools
Standards-Version: 3.9.8
Vcs-Git: git://github.com/AdrianTM/mx-conky

Package: mx-conky
Architecture: any
Depends: mx-conky-data, ${misc:Depends}, ${shlibs:Depends}
Description: MX Conky
 MX Conky is a tool used for manipulating detailed attributes such as color or formats

## mx-conky 19.8

=== debian/changelog ===
mx-conky (19.8) mx; urgency=medium

  * fix icon

 -- Adrian <adrian@mxlinux.org>  Mon, 12 Aug 2019 09:37:43 -0400

## mx-conky 19.8.1

=== debian/changelog ===
mx-conky (19.8.1) mx; urgency=medium

  * added offline help file

 -- Adrian <adrian@mxlinux.org>  Wed, 21 Aug 2019 13:46:29 -0400

## mx-conky 19.9

=== debian/changelog ===
mx-conky (19.9) mx; urgency=medium

  * remove libcmd dependency

 -- Adrian <adrian@mxlinux.org>  Mon, 09 Sep 2019 22:54:11 -0400

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,7 @@
 Section: admin
 Priority: optional
 Maintainer: Adrian <adrian@mxlinux.org>
-Build-Depends: debhelper (>=9),
-               libcmd,
-               qt5-default,
-               qt5-qmake,
-               qttools5-dev-tools
+Build-Depends: debhelper (>=9), qtbase5-dev, qttools5-dev-tools
 Standards-Version: 3.9.8
 Vcs-Git: git://github.com/AdrianTM/mx-conky

## mx-conky 19.9.01

=== debian/changelog ===
mx-conky (19.9.01) mx; urgency=medium

  * new translations

 -- Adrian <adrian@mxlinux.org>  Sun, 29 Sep 2019 14:00:03 -0400

## mx-conky 19.12

=== debian/changelog ===
mx-conky (19.12) mx; urgency=medium

  * remove "no file was selected" message

 -- Adrian <adrian@mxlinux.org>  Fri, 06 Dec 2019 15:49:29 -0500

## mx-conky 20.4

=== debian/changelog ===
mx-conky (20.4) mx; urgency=medium

  * new build for Buster/Stretch

 -- Adrian <adrian@mxlinux.org>  Sat, 11 Apr 2020 15:30:41 -0400

mx-conky (20.03.2) mx; urgency=medium

  * removed ja_JP translations

 -- fehlix <fehlix@mxlinux.org>  Thu, 11 Apr 2020 10:53:31 +0200

mx-conky (20.03.1) mx; urgency=medium

  * add lua-format compatibility, minor fixes

 -- fehlix <fehlix@mxlinux.org>  Thu, 02 Apr 2020 00:53:31 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: mx-conky
 Section: admin
 Priority: optional
-Maintainer: Adrian <adrian@mxlinux.org>
+Maintainer: fehlix <fehlix@mxlinux.org>
+XSBC-Original-Maintainer: Adrian <adrian@mxlinux.org>
 Build-Depends: debhelper (>=9), qtbase5-dev, qttools5-dev-tools
 Standards-Version: 3.9.8
-Vcs-Git: git://github.com/AdrianTM/mx-conky
+Vcs-Git: git://github.com/MX-Linux/mx-conky
 
 Package: mx-conky
 Architecture: any

## mx-conky 20.5

=== debian/changelog ===
mx-conky (20.5) mx; urgency=medium

  * remove %u/%U from editor string

 -- Adrian <adrian@mxlinux.org>  Sun, 30 May 2021 10:42:42 -0400

## mx-conky 21.7

=== debian/control ===
Source: mx-conky
Section: admin
Priority: optional
Maintainer: fehlix <fehlix@mxlinux.org>
XSBC-Original-Maintainer: Adrian <adrian@mxlinux.org>
Build-Depends: 	debhelper (>=10), 
		qtbase5-dev, 
		qttools5-dev-tools
Standards-Version: 3.9.8
Vcs-Git: git://github.com/MX-Linux/mx-conky

Package: mx-conky
Architecture: any
Depends: mx-conky-data, 
	${misc:Depends}, 
	${shlibs:Depends}
Description: MX Conky
 MX Conky is a tool used for manipulating detailed attributes such as color or formats

## mx-conky 21.7.011

=== debian/changelog ===
mx-conky (21.7) mx; urgency=medium

  * Fix mx-conky.conf location

 -- Adrian <adrian@mxlinux.org>  Tue, 20 Jul 2021 16:19:28 -0400

## mx-conky 22.10.01

=== debian/changelog ===
mx-conky (22.10.01) mx; urgency=medium

  * update translations 

 -- Dolphin Oracle <dolphinoracle@gmail.com>  Wed, 26 Oct 2022 19:58:28 -0400

mx-conky (21.7.011) mx; urgency=medium

  * translation refresh

 -- Dolphin Oracle <dolphinoracle@gmail.com>  Sat, 23 Jul 2022 11:23:40 -0400

## mx-conky 22.12.01

=== debian/changelog ===
mx-conky (22.12.01) mx; urgency=medium

  * Fix detection of running conky for current user only
  * Get realpath of detected conkyrc

 -- fehlix <fehlix@mxlinux.org>  Mon, 05 Dec 2022 19:20:33 -0500

## mx-conky 22.12.02

=== debian/changelog ===
mx-conky (22.12.02) mx; urgency=medium

  * Fix handling of spaces in conkyrc path

 -- fehlix <fehlix@mxlinux.org>  Tue, 06 Dec 2022 10:15:30 -0500

## mx-conky 23.4

=== debian/changelog ===
mx-conky (23.4) mx; urgency=medium

  * Update icon
  * Uptate translations

 -- Adrian <adrian@mxlinux.org>  Thu, 13 Apr 2023 22:50:51 -0400

## mx-conky 23.5

=== debian/changelog ===
mx-conky (23.5) mx; urgency=medium

  * Update icon

 -- Adrian <adrian@mxlinux.org>  Sun, 14 May 2023 21:52:57 -0400

## mx-conky 23.5.01

=== debian/changelog ===
mx-conky (23.5.01) mx; urgency=medium

  * Update logo

 -- Adrian <adrian@mxlinux.org>  Wed, 17 May 2023 18:32:43 -0400

## mx-conky 23.7

=== debian/changelog ===
mx-conky (23.7) mx; urgency=medium

  * Update translations

 -- Adrian <adrian@mxlinux.org>  Thu, 20 Jul 2023 16:29:47 -0400

## mx-conky 24.3

=== debian/changelog ===
mx-conky (24.3) mx; urgency=medium

  * Update translations

 -- Adrian <adrian@mxlinux.org>  Sat, 23 Mar 2024 12:35:28 -0400

## mx-conky 25.08

=== debian/changelog ===
mx-conky (25.08) mx; urgency=medium

  * Redesign application with new features:
    - List all conkys with filtering and search options
    - Allow selecting and starting multiple conkys
    - Add autostart checkbox to set conky to start automatically
    - Settings can define multiple directories to scan for conkys
    - Added options for size, location, and transparency
    - Added preview functionality
    - Implement elevation support for editing system conky files
  * Search matches now on the directory name too 
  * Add delete conky option
  * Don't copy anymore all the conkys to ~/.conky, copy only the directory
    that is being edited from /usr/share/mx-conky-data/
  * Add option to enable/disable conky auto-startup
  * Add create previews option
  * Add option to rename the file. Change filter to 'All' after an edit
  * Implement wifi/lan change; fix some Ui resizing, remove drag info
  * Add directory name before the name of the conky
  * Add Enlightenment desktop environment autostart support

 -- Adrian <adrian@mxlinux.org>  Fri, 01 Aug 2025 00:40:03 -0400

mx-conky (24.4) mx; urgency=medium

  * Update to Qt6

 -- Adrian <adrian@mxlinux.org>  Wed, 23 Apr 2025 22:04:32 -0400

=== debian/control ===
Source: mx-conky
Section: admin
Priority: optional
Maintainer: Adrian <adrian@mxlinux.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               qt6-base-dev,
               qt6-base-dev-tools,
               qt6-tools-dev,
               qt6-tools-dev-tools
Standards-Version: 3.9.8
Vcs-Git: git://github.com/MX-Linux/mx-conky
Homepage: https://github.com/MX-Linux/mx-conky

Package: mx-conky
Architecture: any
Depends: mx-conky-data-bin,
	conky-all | conky,
	${misc:Depends},
	${shlibs:Depends}
Recommends: mx-conky-data	 
Description: Conky configuration tool for MX Linux
 MX Conky is a graphical tool used for configuring and managing Conky
 on MX Linux. It allows users to easily customize Conky displays by
 manipulating detailed attributes such as colors, formats, transparency,
 and positioning. The tool provides a user-friendly interface for both
 beginners and advanced users to create and modify Conky configurations
 without manual editing of configuration files.

=== debian/rules ===
#!/usr/bin/make -f
export QT_SELECT=6

override_dh_auto_configure:
	cmake -B build -S . -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/usr

override_dh_auto_clean:
	dh_auto_clean
	rm -f translations/*.qm
	rm -rf build

override_dh_auto_build:
	head -n1 debian/changelog | sed -e "s/.*(\([^(]*\)).*/inline const QString VERSION {\"\1\"};/" > version.h
	cmake --build build

override_dh_auto_install:
	dh_auto_install

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

%:
	dh $@ --no-automatic-dbgsym

## mx-conky 25.08.1

=== debian/changelog ===
mx-conky (25.08.1) mx; urgency=medium

  * Improve conky detections for different encodings

 -- Adrian <adrian@mxlinux.org>  Fri, 01 Aug 2025 16:52:11 -0400

=== debian/rules ===
--- 
+++ 
@@ -10,7 +10,7 @@
 	rm -rf build
 
 override_dh_auto_build:
-	head -n1 debian/changelog | sed -e "s/.*(\([^(]*\)).*/inline const QString VERSION {\"\1\"};/" > version.h
+	head -n1 debian/changelog | sed -e "s/.*(\([^(]*\)).*/inline const QString VERSION {\"\1\"};/" > src/version.h
 	cmake --build build
 
 override_dh_auto_install:

## mx-conky 25.08.2

=== CMakeLists.txt ===
# **********************************************************************
# * Copyright (C) 2017-2025 MX Authors
# *
# * Authors: Adrian
# *          MX Linux <http://mxlinux.org>
# *
# * This file is part of mx-conky.
# *
# * mx-conky is free software: you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation, either version 3 of the License, or
# * (at your option) any later version.
# *
# * mx-conky is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with mx-conky.  If not, see <http://www.gnu.org/licenses/>.
# **********************************************************************/

cmake_minimum_required(VERSION 3.16)

# Get version from debian/changelog
execute_process(
    COMMAND dpkg-parsechangelog -SVersion
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE PROJECT_VERSION_FROM_CHANGELOG
    OUTPUT_STRIP_TRAILING_WHITESPACE
    RESULT_VARIABLE DPKG_RESULT
)

if(NOT DPKG_RESULT EQUAL 0)
    message(FATAL_ERROR "Failed to get version from debian/changelog using dpkg-parsechangelog")
endif()

project(mx-conky
    VERSION ${PROJECT_VERSION_FROM_CHANGELOG}
    DESCRIPTION "MX Conky - Conky configuration tool for MX Linux"
    LANGUAGES CXX
)

# Set C++ standard
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Enable compile commands export for IDEs and tools
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Optimize for Ninja builds
if(CMAKE_GENERATOR STREQUAL "Ninja")
    # Enable colored output for Ninja
    if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
        add_compile_options(-fdiagnostics-color=always)
    elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
        add_compile_options(-fcolor-diagnostics)
    endif()
endif()

# Option to use clang for testing builds
option(USE_CLANG "Use clang compiler" OFF)
if(USE_CLANG)
    set(CMAKE_C_COMPILER clang)
    set(CMAKE_CXX_COMPILER clang++)
    set(CMAKE_CXX_COMPILER_ID "Clang")
    message(STATUS "Using clang compiler")
endif()

# Find Qt6 components
find_package(Qt6 REQUIRED COMPONENTS
    Core
    Gui
    Widgets
    LinguistTools
)

# Enable automatic MOC, UIC, and RCC processing
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

# Define source files
set(SOURCES
    src/main.cpp
    src/mainwindow.cpp
    src/conkymanager.cpp
    src/conkyitem.cpp
    src/conkylistwidget.cpp
    src/conkycustomizedialog.cpp
    src/previewdialog.cpp
    src/settingsdialog.cpp
    src/cmd.cpp
)

set(HEADERS
    src/mainwindow.h
    src/conkymanager.h
    src/conkyitem.h
    src/conkylistwidget.h
    src/conkycustomizedialog.h
    src/previewdialog.h
    src/settingsdialog.h
    src/cmd.h
    src/version.h
)

set(RESOURCE_FILES
    images.qrc
)

# Get all translation files
file(GLOB TRANSLATION_FILES "translations/*.ts")

# Create the executable
add_executable(mx-conky
    ${SOURCES}
    ${HEADERS}
    ${RESOURCE_FILES}
)

# Link Qt6 libraries
target_link_libraries(mx-conky
    Qt6::Core
    Qt6::Gui
    Qt6::Widgets
)

# Set compiler flags
target_compile_options(mx-conky PRIVATE
    -Wpedantic
    -pedantic
    -Werror=return-type
    -Werror=switch
    -Werror=uninitialized
    -Werror
)

# Add compiler-specific flags
if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
    target_compile_options(mx-conky PRIVATE -Werror=return-stack-address)
else()
    target_compile_options(mx-conky PRIVATE -Werror=return-local-addr)
endif()

# Set compile definitions
target_compile_definitions(mx-conky PRIVATE
    QT_DEPRECATED_WARNINGS
    QT_DISABLE_DEPRECATED_BEFORE=0x060000
)

# Release-specific optimizations
if(CMAKE_BUILD_TYPE STREQUAL "Release")
    target_compile_definitions(mx-conky PRIVATE NDEBUG)
    target_compile_options(mx-conky PRIVATE -O3)

    # Add LTO - different flags for different compilers
    if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
        target_compile_options(mx-conky PRIVATE -flto=thin)
        target_link_options(mx-conky PRIVATE -flto=thin)
    else()
        target_compile_options(mx-conky PRIVATE -flto=auto)
        target_link_options(mx-conky PRIVATE -flto=auto)
    endif()
endif()

# Handle translations
qt6_add_translations(mx-conky
    TS_FILES ${TRANSLATION_FILES}
    QM_FILES_OUTPUT_VARIABLE qm_files
)

# Generate version.h file
configure_file(
    "${CMAKE_SOURCE_DIR}/version.h.in"
    "${CMAKE_BINARY_DIR}/src/version.h"
    @ONLY
)

# Set target properties
set_target_properties(mx-conky PROPERTIES
    OUTPUT_NAME "mx-conky"
    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
)

# Add build directory to include path for generated version.h
target_include_directories(mx-conky PRIVATE ${CMAKE_BINARY_DIR}/src)

# Install target (required by Debian build system)
# Other files are handled by debian/install
install(TARGETS mx-conky
    RUNTIME DESTINATION bin
)

=== debian/changelog ===
mx-conky (25.08.2) mx; urgency=medium

  * Move Customize button to the first position in the row of buttons

 -- Adrian <adrian@mxlinux.org>  Tue, 19 Aug 2025 18:41:48 -0400

## mx-conky 25.09

=== debian/changelog ===
mx-conky (25.09) mx; urgency=medium

  * Change contrast for location path

 -- Adrian <adrian@mxlinux.org>  Fri, 05 Sep 2025 09:37:16 -0400

## mx-conky 25.09.2

=== debian/changelog ===
mx-conky (25.09.2) mx; urgency=medium

  * Set font sizes according to user preference

 -- Adrian <adrian@mxlinux.org>  Thu, 18 Sep 2025 08:41:24 -0400

## mx-conky 25.09.4

=== debian/changelog ===
mx-conky (25.09.4) mx; urgency=medium

  * Create links for the fonts in /usr/share/mx-conky-data/themes

 -- Adrian <adrian@mxlinux.org>  Wed, 24 Sep 2025 17:35:11 -0400

## mx-conky 25.10

=== debian/changelog ===
mx-conky (25.10) mx; urgency=medium

  * Get autostart items from the startup script
  * Add 'autostart' filter

 -- Adrian <adrian@mxlinux.org>  Wed, 01 Oct 2025 14:36:23 -0400

## mx-conky 25.10.1

=== debian/changelog ===
mx-conky (25.10.1) mx; urgency=medium

  * Change transparenty detection scheme

 -- Adrian <adrian@mxlinux.org>  Fri, 10 Oct 2025 23:31:10 -0400

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,7 @@
 Section: admin
 Priority: optional
 Maintainer: Adrian <adrian@mxlinux.org>
-Build-Depends: debhelper-compat (= 13),
-               cmake,
-               qt6-base-dev,
-               qt6-base-dev-tools,
-               qt6-tools-dev,
-               qt6-tools-dev-tools
+Build-Depends: debhelper-compat (=12), cmake (>= 3.16), ninja-build, qt6-base-dev, qt6-base-dev-tools, qt6-tools-dev, qt6-tools-dev-tools
 Standards-Version: 3.9.8
 Vcs-Git: git://github.com/MX-Linux/mx-conky
 Homepage: https://github.com/MX-Linux/mx-conky

## mx-conky 25.10.2

=== debian/changelog ===
mx-conky (25.10.2) mx; urgency=medium

 * Add graphicsmagick-imagemagick-compat as a recommend and popup a message that it's missing if the user tries to create a preview
 * When backing up a conky refresh and add it to the list Don't show successful deletion dialog, it should be obvious since the entry disappears from list
 * Preserve filter selection when editing a conky

 -- Adrian <adrian@mxlinux.org>  Mon, 20 Oct 2025 14:11:55 -0400

## mx-conky 25.10.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -102,7 +102,6 @@
     src/previewdialog.h
     src/settingsdialog.h
     src/cmd.h
-    src/version.h
 )
 
 set(RESOURCE_FILES
@@ -147,6 +146,7 @@
 target_compile_definitions(mx-conky PRIVATE
     QT_DEPRECATED_WARNINGS
     QT_DISABLE_DEPRECATED_BEFORE=0x060000
+    VERSION="${PROJECT_VERSION}"
 )
 
 # Release-specific optimizations
@@ -167,15 +167,11 @@
 # Handle translations
 qt6_add_translations(mx-conky
     TS_FILES ${TRANSLATION_FILES}
+    LRELEASE_OPTIONS -compress -nounfinished -removeidentical -silent
     QM_FILES_OUTPUT_VARIABLE qm_files
 )
 
-# Generate version.h file
-configure_file(
-    "${CMAKE_SOURCE_DIR}/version.h.in"
-    "${CMAKE_BINARY_DIR}/src/version.h"
-    @ONLY
-)
+
 
 # Set target properties
 set_target_properties(mx-conky PROPERTIES
@@ -183,8 +179,7 @@
     RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
 )
 
-# Add build directory to include path for generated version.h
-target_include_directories(mx-conky PRIVATE ${CMAKE_BINARY_DIR}/src)
+
 
 # Install target (required by Debian build system)
 # Other files are handled by debian/install

=== debian/changelog ===
mx-conky (25.10.3) mx; urgency=medium

 * Add 12h/24h auto time-format detection and toggle for template-pmfix
 * Add 12h/24h auto time-format detection and toggle for lua hour and lua am_pm
 * Fix to ignore comment lines when detecting and adjusting 12h/24h auto time-format

 -- fehlix <fehlix@mxlinux.org>  Wed, 22 Oct 2025 19:38:40 -0400

## mx-conky 25.10.5

=== debian/changelog ===
mx-conky (25.10.5) mx; urgency=medium

  * Allow 'auto' time display selection for conky's which are auto-capable

 -- Adrian <adrian@mxlinux.org>  Fri, 24 Oct 2025 09:23:50 -0400

mx-conky (25.10.4) mx; urgency=medium

  * Allow "auto" 12h/24h time display selection for conky's which are auto-capable

 -- fehlix <fehlix@mxlinux.org>  Fri, 24 Oct 2025 06:13:00 -0400

## mx-conky 25.10.6

=== debian/changelog ===
mx-conky (25.10.6) mx; urgency=medium

  * Stop All now stays disabled when no conkys are running, and the
    filtered list refreshes automatically after the global actions.

 -- Adrian <adrian@mxlinux.org>  Tue, 28 Oct 2025 13:21:41 -0400

## mx-conky 25.10.7

=== debian/changelog ===
mx-conky (25.10.7) mx; urgency=medium

  * Change default delay to 10 seconds.

 -- Adrian <adrian@mxlinux.org>  Tue, 28 Oct 2025 22:29:15 -0400

## mx-conky 25.10.9

=== debian/changelog ===
mx-conky (25.10.9) mx; urgency=medium

  * Additional conky detection fix

 -- Adrian <adrian@mxlinux.org>  Wed, 29 Oct 2025 13:38:48 -0400

mx-conky (25.10.8) mx; urgency=medium

  * Stop All now stays enabled and sends a pkill/killall sweep so every
    conky owned by the user is terminated, even when detection misses
    them.
  * Improve running conkys detection/stopping

 -- Adrian <adrian@mxlinux.org>  Wed, 29 Oct 2025 12:18:14 -0400

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,8 @@
 	conky-all | conky,
 	${misc:Depends},
 	${shlibs:Depends}
-Recommends: mx-conky-data	 
+Recommends: mx-conky-data,
+	graphicsmagick-imagemagick-compat
 Description: Conky configuration tool for MX Linux
  MX Conky is a graphical tool used for configuring and managing Conky
  on MX Linux. It allows users to easily customize Conky displays by

=== debian/rules ===
#!/usr/bin/make -f
export QT_SELECT=6

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=Release \
		-DCMAKE_EXPORT_COMPILE_COMMANDS=ON

override_dh_auto_clean:
	dh_auto_clean
	rm -rf build/
	rm -f translations/*.qm
	rm -f src/version.h

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

override_dh_auto_test:
	# Skip tests as no test targets are defined

override_dh_auto_install:
	dh_auto_install

%:
	dh $@ --buildsystem=cmake+ninja --no-automatic-dbgsym

## mx-conky 25.11

=== debian/changelog ===
mx-conky (25.11) mx; urgency=medium

  * 1e23e48 Improve font linking/copying logic
  * 5006aae Allow conkys defined in hidden files

 -- Adrian <adrian@mxlinux.org>  Fri, 14 Nov 2025 12:04:52 -0500
